#ifndef GLOBAL_H_INCLUDED
#define GLOBAL_H_INCLUDED
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include "i2cmaster.h"
#include <avr/pgmspace.h>

#define DS1307_I2C_ADDRESS 0XD0

#define SCL_CLOCK 100000L

#define XTAL        16e6
#define PHASE_A     (PINA & 1<<PA0)
#define PHASE_B     (PINA & 1<<PA1)

#define MOD_Normal              0b00000000
#define MOD_Sleep               0b00000001
#define MOD_AlarmEin            0b00000010
#define MOD_DCF                 0b00000100
#define MOD_AlarmHour           0b00001000
#define MOD_AlarmMin            0b00010000
#define MOD_Nacht               0b00100000
//switchcase
extern int8_t Modus;
extern uint8_t DCFempfang;
extern uint8_t Alarmzeit;
extern uint8_t AlarmEin;
extern uint8_t Uhrzeitstellen;
extern uint8_t SleepEin;
extern void switchfkt(void);
//Uhrzeit
extern volatile uint8_t ss;     //aktuelle Sekunde
extern uint8_t mm;              //aktuelle Minute
extern uint8_t hh;              //aktuelle Stunde
extern uint8_t dd;               //aktueller Tag
extern uint8_t doW;             //aktueller Wochentag
extern uint8_t m;               //aktueller Monat
extern uint8_t y;               //akutelles Jahr
//Weckzeit
extern volatile int8_t ssW;
extern volatile int8_t hhW;
extern volatile int8_t mmW;
extern uint8_t Alarmzeit;
//DCF
extern volatile uint8_t dcfcounter;
extern volatile uint16_t pausecounter;
extern volatile uint8_t recieving;
extern volatile uint8_t dcfbufferposition;
extern volatile uint16_t dcf[60];
extern volatile uint8_t cnt;
extern void DCFempfangen();
//Matrixanzeige
extern int load;
extern void Digi (uint8_t, uint8_t);
extern void Anzeigen (int, int, int, int, int);
extern void AnzeigenSS(int);
extern void UhrzeitUeberlauf (void);
extern void maxSingle(char, char);
extern void DCFzeit();
//Drehencoder
extern volatile int8_t enc_delta;
extern int8_t last;
extern volatile int8_t val;
extern int8_t encode_read1(void);
extern void long_delay(uint16_t);
//max7221
extern void MAX_init ();
extern void MAX_initialisieren(void);
extern void deimm(uint8_t, uint8_t);
extern void deimmAll(uint8_t);
extern void deimmAllAus(void);
extern uint8_t deimmMaxAus;
//Taster
extern void tasterAlarmzeit(int, int);
extern void tasterX(int, int);
extern void tasterDCFempfang(int, int);
extern void tasterSleep(int, int);
extern void tasterAlarmEin(int, int);
//Sound
extern volatile uint16_t toene[];
extern const uint16_t laenge[] PROGMEM;
extern uint8_t tasterXHelper;
extern volatile uint16_t  u16Tick;
extern volatile uint8_t   u8PauseTicker;
extern volatile int8_t   u8ActTon;
//Laufschrift
extern void Laufschrift(uint8_t *lar);
extern uint8_t larray[];
extern uint8_t StarWars[];
//extern volatile int8_t laufschriftcounter;
//RTC DS1307
extern char BCD2Dec(char);
extern void timeToDS1307(char, char);
extern void timeFromDS1307(void);
#endif // GLOBAL_H_INCLUDED
