#include "global.h"

// ******  MAX7219 KONFIGURATION ******** //

int dataIn = PB0;       //  PB0 Maxim7219 In
int load = PB2;         //  PB2/PB3/PB4 Signalleitung
int clock = PB1;        //  PB1 Takt

int maxInUse = 1;    //falls MAX7219 in Reihe geschaltet //bei mir nicht

int e;           // just a varialbe

// max7219 registers
char max7219_reg_noop        = 0x00;
char max7219_reg_digit0      = 0x01;
char max7219_reg_digit1      = 0x02;
char max7219_reg_digit2      = 0x03;
char max7219_reg_digit3      = 0x04;
char max7219_reg_digit4      = 0x05;
char max7219_reg_digit5      = 0x06;
char max7219_reg_digit6      = 0x07;
char max7219_reg_digit7      = 0x08;
char max7219_reg_decodeMode  = 0x09;
char max7219_reg_intensity   = 0x0a;
char max7219_reg_scanLimit   = 0x0b;
char max7219_reg_shutdown    = 0x0c;
char max7219_reg_displayTest = 0x0f;

uint8_t deimmMaxAus = 0;

void putachar(char data) {
  char i = 8;
  char mask;
  while(i > 0) {
    mask = 0x01 << (i - 1);      // get bitmask
    PORTB &= ~(1 << clock);//digitalWrite( clock, LOW);   // tick
    if (data & mask){            // choose bit
      PORTB |= (1 << dataIn);//digitalWrite(dataIn, HIGH);// send 1
    }else{
      PORTB &= ~(1 << dataIn);//digitalWrite(dataIn, LOW); // send 0
    }
    PORTB |= (1 << clock);//digitalWrite(clock, HIGH);   // tock
    --i;                         // move to lesser bit
  }
}

void maxSingle(char reg, char col) {
//maxSingle is the "easy"  function to use for a     //single max7219

  PORTB &= ~(1 << load);//DigitalWrite(load, LOW);       // begin
  putachar(reg);                  // specify register
  putachar(col);//((data & 0x01) * 256) + data >> 1); // put data
  PORTB &= ~(1 << load);//digitalWrite(load, LOW);       // and load da shit
  PORTB |= (1 << load);//digitalWrite(load,HIGH);
}

void maxAll (char reg, char col) {    // initialize  all  MAX7219's in the system
  int c = 0;
  PORTB &= ~(1 << load);//digitalWrite(load, LOW);  // begin
  for ( c =1; c<= maxInUse; c++) {
  putachar(reg);  // specify register
  putachar(col);//((data & 0x01) * 256) + data >> 1); // put data
    }
  PORTB &= ~(1 << load);//digitalWrite(load, LOW);
  PORTB |= (1 << load);//digitalWrite(load,HIGH);
}

void maxOne(char maxNr, char reg, char col) {
//maxOne is for adressing different MAX7219's,
//whilele having a couple of them cascaded

  int c = 0;
  PORTB &= ~(1 << load);//digitalWrite(load, LOW);  // begin

  for ( c = maxInUse; c > maxNr; c--) {
    putachar(0);    // means no operation
    putachar(0);    // means no operation
  }

  putachar(reg);  // specify register
  putachar(col);//((data & 0x01) * 256) + data >> 1); // put data

  for ( c =maxNr-1; c >= 1; c--) {
    putachar(0);    // means no operation
    putachar(0);    // means no operation
  }

  PORTB &= ~(1 << load);//digitalWrite(load, LOW); // and load da shit
  PORTB |= (1 << load);//digitalWrite(load,HIGH);
}

void MAX_init (void) {
DDRB |= (1 << dataIn) | (1 << clock) | (1 << load) | (1 << PB3) | (1 << PB4);

//initiation of the max 7219
  maxAll(max7219_reg_scanLimit, 0x07);
  maxAll(max7219_reg_decodeMode, 0x00);  // using an led matrix (not digits)
  maxAll(max7219_reg_shutdown, 0x01);    // not in shutdown mode
  maxAll(max7219_reg_displayTest, 0x00); // no display test
   for (e=1; e<=8; e++) {    // empty registers, turn all LEDs off
    maxAll(e,0);
  }
  maxAll(max7219_reg_intensity, 0x0f & 0x0f);    // the first 0x0f is the value you can set
                                                  // range: 0x00 to 0x0f
}


void deimm (uint8_t Stufe, uint8_t Chip) {
    if (deimmMaxAus == 1)
    {
        deimmMaxAus = 0;
        MAX_initialisieren();
    }
    if (Chip == 1) {
    load = PB2;
    }
    if (Chip == 2 ) {
    load = PB3;
    }
    if (Chip == 3) {
    load = PB4;
    }
    maxAll(max7219_reg_intensity, Stufe & 0x0f);
}

void deimmAll(uint8_t Stufe)
{
    if (deimmMaxAus == 1)
    {
        MAX_initialisieren();
        deimmMaxAus = 0;
    }
    load = PB2;
    maxAll(max7219_reg_intensity, Stufe & 0x0f);
    load = PB3;
    maxAll(max7219_reg_intensity, Stufe & 0x0f);
    load = PB4;
    maxAll(max7219_reg_intensity, Stufe & 0x0f);

}

void deimmAllAus(void) {
    load = PB2;
    maxAll(0x0c, 0x00);
    load = PB3;
    maxAll(0x0c, 0x00);
    load = PB4;
    maxAll(0x0c, 0x00);
    deimmMaxAus = 1;
}

void MAX_initialisieren(void) {
// MAX 7221 initialisieren
    load = PB3;
    MAX_init();
    load = PB4;
    MAX_init();
    load = PB2;
    MAX_init();

}
