#include "global.h"

void Digi (uint8_t ZahlDig, uint8_t AuswDig)
{
    /*   _A_            A = 64
       F|   |B          B = 32
        |_G_|           C = 16
       E|   |C          D = 8
        |_D_|  .DP      E = 4
                        F = 2
                        G = 1
                        DP=
    */
    load = PB4;

    switch (ZahlDig)
    {
        case 0:
        {
            maxSingle(AuswDig, 254);
            break;
        }
        case 1:
        {
            maxSingle(AuswDig, 16+32);
            break;
        }
        case 2:
        {
            maxSingle(AuswDig, 1+4+8+32+64);
            break;
        }
        case 3:
        {
            maxSingle(AuswDig, 64+32+1+16+8);
            break;
        }
        case 4:
        {
            maxSingle(AuswDig, 2+1+32+16);
            break;
        }
        case 5:
        {
            maxSingle(AuswDig, 64+2+1+16+8);
            break;
        }
        case 6:
        {
            maxSingle(AuswDig, 64+2+1+4+8+16);
            break;
        }
        case 7:
        {
            maxSingle(AuswDig, 64+32+16);
            break;
        }
        case 8:
        {
            maxSingle(AuswDig, 127);
            break;
        }
        case 9:
        {
            maxSingle(AuswDig, 64+2+1+32+16+8);
            break;
        }

//        case 10:
//        {
//            maxSingle(AuswDig, 254+128);
//            break;
//        }
//        case 11:
//        {
//            maxSingle(AuswDig, 16+32+128);
//            break;
//        }
//        case 12:
//        {
//            maxSingle(AuswDig, 1+4+8+32+64+128);
//            break;
//        }
//        case 13:
//        {
//            maxSingle(AuswDig, 64+32+1+16+8+128);
//            break;
//        }
//        case 14:
//        {
//            maxSingle(AuswDig, 2+1+32+16+128);
//            break;
//        }
//        case 15:
//        {
//            maxSingle(AuswDig, 64+2+1+16+8+128);
//            break;
//        }
//        case 16:
//        {
//            maxSingle(AuswDig, 64+2+1+4+8+16+128);
//            break;
//        }
//        case 17:
//        {
//            maxSingle(AuswDig, 64+32+16+128);
//            break;
//        }
//        case 18:
//        {
//            maxSingle(AuswDig, 127+128);
//            break;
//        }
//        case 19:
//        {
//            maxSingle(AuswDig, 64+2+1+32+16+8+128);
//            break;
//        }

        case 42:
        {
            maxSingle(AuswDig, 128);
            break;
        }
        case 77:
        {
            maxSingle(AuswDig, 1+2+4+16+32+64);
            break;
        }
        case 78:
        {
            maxSingle(AuswDig, 1+2+4+16);
            break;
        }
        case 79:
        {
            maxSingle(AuswDig, 1+4+8+16);
            break;
        }
        case 80:
        {
            maxSingle(AuswDig, 4+64);
            break;
        }
        case 81:
        {
            maxSingle(AuswDig, 1+2+4+16);
            break;
        }
        case 88:
        {
            maxSingle(AuswDig, 1+2+16);
            break;
        }

    }
}


char Schrift[79] =
{
    0b00000000,
    // Zahl 0
    0b01111100,
    0b01000100,
    0b01111100,

    // Zahl 1
    0b01111100,
    0b00100000,
    0b00010000,

    // Zahl 2
    0b01110100,
    0b01010100,
    0b01011100,

    // Zahl 3
    0b01111100,
    0b01010100,
    0b01010100,

    // Zahl 4
    0b01111100,
    0b00010000,
    0b01110000,

    //Zahl 5
    0b01011100,
    0b01010100,
    0b01110100,

    //Zahl 6
    0b01011100,
    0b01010100,
    0b01111100,

    //Zahl 7
    0b01111100,
    0b01000000,
    0b01000000,

    //Zahl 8
    0b01111100,
    0b01010100,
    0b01111100,

    //Zahl 9
    0b01111100,
    0b01010100,
    0b01110100,

    //"Zahl" 10 -- -- für Nulldetektor
    0b00001100,
    0b00010000,
    0b01100000,
};

void Segment (uint8_t Zahl, uint8_t LR, uint8_t matrix)
{
    if (matrix == 2)
    {
        load = PB2;

        int z;
        int h;

        if (Zahl == 0) z = 0;
        if (Zahl == 1) z = 3*Zahl;
        if (Zahl == 2) z = 3*Zahl;
        if (Zahl == 3) z = 3*Zahl;
        if (Zahl == 4) z = 3*Zahl;
        if (Zahl == 5) z = 3*Zahl;
        if (Zahl == 6) z = 3*Zahl;
        if (Zahl == 7) z = 3*Zahl;
        if (Zahl == 8) z = 3*Zahl;
        if (Zahl == 9) z = 3*Zahl;

        if (LR == 2) h = 0;
        if (LR == 1) h = 4;

        maxSingle(1 + h, Schrift[1+z]);
        maxSingle(2 + h, Schrift[2+z]);
        maxSingle(3 + h, Schrift[3+z]);
        maxSingle(4 + h, Schrift[0]);
        maxSingle(1 + h, Schrift[1+z]);
        maxSingle(2 + h, Schrift[2+z]);
        maxSingle(3 + h,  Schrift[3+z]);
    }

    if (matrix == 1)
    {
        load = PB3;

        int z;
        int h;

        if (Zahl == 0) z = 0;
        if (Zahl == 1) z = 3*Zahl;
        if (Zahl == 2) z = 3*Zahl;
        if (Zahl == 3) z = 3*Zahl;
        if (Zahl == 4) z = 3*Zahl;
        if (Zahl == 5) z = 3*Zahl;
        if (Zahl == 6) z = 3*Zahl;
        if (Zahl == 7) z = 3*Zahl;
        if (Zahl == 8) z = 3*Zahl;
        if (Zahl == 9) z = 3*Zahl;


        if (LR == 2) h = 0;
        if (LR == 1) h = 4;

        maxSingle(1 + h, Schrift[1+z]);
        maxSingle(2 + h, Schrift[2+z]);
        maxSingle(3 + h, Schrift[3+z]);
        maxSingle(4 + h, Schrift[0]);
        maxSingle(1 + h, Schrift[1+z]);
        maxSingle(2 + h, Schrift[2+z]);
        maxSingle(3 + h, Schrift[3+z]);
    }
}
void AnzeigenSS(int ssA)
{
    uint8_t ESs = 0;
    uint8_t ZSs = 0;

    ESs = ssA % 10;
    ZSs = (ssA % 100)/10;

    Digi(ZSs, 2);
    Digi(ESs, 1);
}

void AnzeigenMM(int mmA)
{
    uint8_t EM = 0;
    uint8_t ZM = 0;

    EM = mmA % 10;
    ZM = (mmA % 100)/10;

    Segment(ZM, 1, 1);
    Segment(EM, 2, 1);
}

void AnzeigenHH(int hhA)
{
    uint8_t ES = 0;
    uint8_t ZS = 0;

    ES = hhA % 10;
    ZS = (hhA % 100)/10;

    Segment(ZS, 1, 2);
    Segment(ES, 2, 2);
}

void AnzeigenDD(int ddA)
{
    uint8_t EDY = 0;
    uint8_t ZDY = 0;

    EDY =ddA % 10;
    ZDY = (ddA % 100)/10;

    Digi(EDY, 5); //+10 wegen dem dotpoint
    Digi(ZDY, 6);
}

void AnzeigenMO(int mA)
{
    uint8_t EMO = 0;
    uint8_t ZMO = 0;

    EMO = mA % 10;
    ZMO = (mA % 100)/10;

    Digi(EMO, 3); //+10 wegen dem dotpoint
    Digi(ZMO, 4);
}

// Den Shit auf die Matrizen jagen
void Anzeigen (int ssA, int mmA, int hhA, int ddA, int mA) {
    uint8_t EM = 0;
    uint8_t ZM = 0;
    uint8_t ES = 0;
    uint8_t ZS = 0;

    uint8_t ESs = 0;
    uint8_t ZSs = 0;
    uint8_t EDY = 0;
    uint8_t ZDY = 0;
    uint8_t EMO = 0;
    uint8_t ZMO = 0;

    // Zählerauflösung
    ESs = ssA % 10;
    ZSs = (ssA % 100)/10;

    EM = mmA % 10;
    ZM = (mmA % 100)/10;
    ES = hhA % 10;
    ZS = (hhA % 100)/10;

    if (ddA == 77 && mA == 77)
    {
        EDY = 81;
        ZDY = 77;
        EMO = 80;
        ZMO = 79;
    }
    else if (ddA == 88 && mA == 88)
    {
        EDY = 88;
        ZDY = 88;
        EMO = 88;
        ZMO = 88;
    }
    else
    {
        EDY =ddA % 10;
        ZDY = (ddA % 100)/10;
        EMO = mA % 10;
        ZMO = (mA % 100)/10;

    }

    // Matrix (Zahl, welche Seite auf Matrix, welche Matrix)
    Segment(ZS, 1, 2);
    Segment(ES, 2, 2);
    Segment(ZM, 1, 1);
    Segment(EM, 2, 1);

    // 7-Segmentanzeigen (Zahl, 7-segmentanzeige)
    Digi(ZSs, 2);
    Digi(ESs, 1);
    Digi(EMO, 3); //+10 wegen dem dotpoint
    Digi(ZMO, 4);
    Digi(EDY, 5); //+10 wegen dem dotpoint
    Digi(ZDY, 6);

}

uint8_t mdays[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

void UhrzeitUeberlauf (void)
{

    if (ss == 60) {                             //jede Minute
        ss = 0;
        mm++;
        AnzeigenMM(mm);
        if (mm == 60) {                         //jede Stunde
            mm = 0;
            hh++;
            AnzeigenHH(hh);
            if (hh == 24) {                     //jeden Tag
                hh = 0;
               dd++;
               AnzeigenDD(dd);
                doW++;
                if (doW == 8){                  //jede Woche
                    doW = 1;
                }
                if (dd == ((mdays[m-1]) + 1)){  //jeden Monat
                    dd = 0;
                    m++;
                    AnzeigenMM(m);
                    if (m == 13){               //jedes Jahr
                        m = 0;
                        y++;
                        if (y == 100){          //jedes Jahrhundert
                            y = 0;
                        }
                    }
                }
            }
        }
    }
}

